unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ScktComp;

type
  Twebio_ascii_client = class(TForm)
    gb_io: TGroupBox;
    bt_counterreadall: TButton;
    bt_counterclearall: TButton;
    lb_counterall: TLabel;
    bt_inputsread: TButton;
    bt_outputsread: TButton;
    cb_output_polling: TCheckBox;
    cb_input_polling: TCheckBox;
    cb_counter_polling: TCheckBox;
    Label1: TLabel;
    ed_interval: TEdit;
    gb_connection: TGroupBox;
    Label2: TLabel;
    ed_ip: TEdit;
    ed_port: TEdit;
    bt_connect: TButton;
    bt_disconnect: TButton;
    StatusBar1: TStatusBar;
    ClientSocket1: TClientSocket;
    timer_polling: TTimer;
    ed_password: TEdit;
    lb_port: TLabel;
    lb_password: TLabel;
    cb_output0: TCheckBox;
    cb_output1: TCheckBox;
    cb_output2: TCheckBox;
    cb_output3: TCheckBox;
    cb_output4: TCheckBox;
    cb_output5: TCheckBox;
    cb_output6: TCheckBox;
    cb_output7: TCheckBox;
    cb_output8: TCheckBox;
    cb_output9: TCheckBox;
    cb_output10: TCheckBox;
    cb_output11: TCheckBox;
    cb_input0: TCheckBox;
    cb_input1: TCheckBox;
    cb_input2: TCheckBox;
    cb_input3: TCheckBox;
    cb_input4: TCheckBox;
    cb_input5: TCheckBox;
    cb_input6: TCheckBox;
    cb_input7: TCheckBox;
    cb_input8: TCheckBox;
    cb_input9: TCheckBox;
    cb_input10: TCheckBox;
    cb_input11: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    ed_counter0: TEdit;
    ed_counter1: TEdit;
    ed_counter2: TEdit;
    ed_counter3: TEdit;
    ed_counter4: TEdit;
    ed_counter5: TEdit;
    ed_counter6: TEdit;
    ed_counter7: TEdit;
    ed_counter8: TEdit;
    ed_counter9: TEdit;
    ed_counter10: TEdit;
    ed_counter11: TEdit;
    bt_counterread0: TButton;
    bt_counterclear0: TButton;
    bt_counterread1: TButton;
    bt_counterclear1: TButton;
    bt_counterread2: TButton;
    bt_counterclear2: TButton;
    bt_counterread3: TButton;
    bt_counterclear3: TButton;
    bt_counterread4: TButton;
    bt_counterclear4: TButton;
    bt_counterread5: TButton;
    bt_counterclear5: TButton;
    bt_counterread6: TButton;
    bt_counterclear6: TButton;
    bt_counterread7: TButton;
    bt_counterclear7: TButton;
    bt_counterread8: TButton;
    bt_counterclear8: TButton;
    bt_counterread9: TButton;
    bt_counterclear9: TButton;
    bt_counterread10: TButton;
    bt_counterclear10: TButton;
    bt_counterread11: TButton;
    bt_counterclear11: TButton;
    procedure bt_connectClick(Sender: TObject);
    procedure bt_disconnectClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure bt_outputsreadClick(Sender: TObject);
    procedure bt_inputsreadClick(Sender: TObject);
    procedure bt_counterreadClick(Sender: TObject);
    procedure bt_counterreadallClick(Sender: TObject);
    procedure bt_counterclearallClick(Sender: TObject);
    procedure bt_counterclearClick(Sender: TObject);
    procedure timer_pollingTimer(Sender: TObject);
    procedure ed_intervalChange(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure cb_outputMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  MAXI=11;
  MAXO=11;
  BITSET : array [0..11] of longword =
      ( 1, 2, 4, 8,
        $10, $20, $40, $80,
        $100, $200, $400, $800);
  OUTSET : array [0..11] of String =
      ( '0001', '0002', '0004', '0008',
        '0010', '0020', '0040', '0080',
        '0100', '0200', '0400', '0800');

var
  webio_ascii_client: Twebio_ascii_client;
  {cb_output : array [0..MAXO] of tcheckbox;
  cb_input : array [0..MAXI] of tcheckbox;
  lb_counter : array [0..MAXI] of tlabel;
  ed_counter : array [0..MAXI] of tedit;
  bt_counterread : array [0..MAXI] of tButton;
  bt_counterclear : array [0..MAXI] of tButton; }

implementation
{$R *.DFM}

function HexToInt(HexString : String) : longWord;
var CharCount           : integer;
    HexCharValue        : longWord;
    HexValue            : longWord;
begin
   HexValue := 0;
   HexString := UpperCase(HexString);
   for CharCount := 1 to length(HexString) do
   begin
     HexCharValue := ord(HexString[CharCount]);
     if HexCharValue > 57 then
        HexCharValue := HexCharValue - 55
     else
        HexCharValue := HexCharValue - 48;
     HexCharValue := HexCharValue shl ((length(HexString) - CharCount) *  4);
     HexValue := HexValue or HexCharValue;
   end;
   HexToInt := HexValue;
end;

procedure Twebio_ascii_client.FormCreate(Sender: TObject);
begin
  StatusBar1.SimpleText := 'No Connection';
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.bt_connectClick(Sender: TObject);
begin
  if ed_ip.Text <> '' then
  begin
    ClientSocket1.Host := ed_ip.Text;
    ClientSocket1.Port := strtoint(ed_port.Text);
    ClientSocket1.Active := True;
  end;
end;

procedure Twebio_ascii_client.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.SimpleText := 'Connected to ' + ed_ip.Text;
  bt_connect.Enabled := False;
  bt_disconnect.Enabled := True;
  gb_io.Enabled := True;
end;

procedure Twebio_ascii_client.bt_disconnectClick(Sender: TObject);
begin
  ClientSocket1.Active := False;
end;

procedure Twebio_ascii_client.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ClientSocket1.Active := False;
  StatusBar1.SimpleText := 'No Connection';
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ClientSocket1.Active := False;
  StatusBar1.SimpleText := 'Error ' + inttostr(ErrorCode) + ' - No Connection';
  ErrorCode := 0;
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.bt_outputsreadClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /output?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.cb_outputMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var dummycount : word;
    outputno : word;
begin
  for dummycount := 0 to MAXO do
    if sender = (FindComponent( 'cb_output' + inttostr(dummycount))as tcheckbox) then
      outputno := dummycount;
  if (FindComponent( 'cb_output' + inttostr(outputno))as tcheckbox).Checked then
    clientsocket1.Socket.SendText('GET /outputaccess?PW=' + ed_password.Text
    + '&Mask=' + OUTSET[outputno] + '&State=' + OUTSET[outputno] + '&')
  else
    clientsocket1.Socket.SendText('GET /outputaccess?PW=' + ed_password.Text
    + '&Mask=' + OUTSET[outputno] + '&State=0000&');
end;

procedure Twebio_ascii_client.bt_inputsreadClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /input?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counterreadClick(Sender: TObject);
var dummycount : word;
begin
  for dummycount := 0 to MAXO do
    if sender = (FindComponent( 'bt_counterread' + inttostr(dummycount))as tButton) then
      clientsocket1.Socket.SendText('GET /counter'
        + inttostr(dummycount)+'?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counterreadallClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /counter?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.bt_counterclearClick(Sender: TObject);
var dummycount : word;
begin
  for dummycount := 0 to MAXO do
    if sender = (FindComponent( 'bt_counterclear' + inttostr(dummycount))as tbutton) then
      clientsocket1.Socket.SendText('GET /counterclear'
        + inttostr(dummycount)+'?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counterclearallClick(Sender: TObject);
begin
  ClientSocket1.Socket.
      SendText('GET /counterclear?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.timer_pollingTimer(Sender: TObject);
begin
  if ClientSocket1.Active and cb_output_polling.Checked then
    ClientSocket1.Socket.SendText('GET /output?PW=' + ed_password.Text + '&');
  if ClientSocket1.Active and cb_input_polling.Checked then
    ClientSocket1.Socket.SendText('GET /input?PW=' + ed_password.Text + '&');
  if ClientSocket1.Active and cb_counter_polling.Checked then
    ClientSocket1.Socket.SendText('GET /counter?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.ed_intervalChange(Sender: TObject);
begin
  timer_polling.Interval := strtoint(ed_interval.Text);
end;

procedure Twebio_ascii_client.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var ReceiveString : String;
    HexValue : word;
    dummycount : word;
begin
  ReceiveString := ClientSocket1.Socket.ReceiveText;
  if Receivestring[1] = 'o' then //Output-Meldungen auswerten
  begin
    HexValue := HextoInt(copy(ReceiveString,
      pos(';',ReceiveString)+1,length(ReceiveString)-pos(';',ReceiveString)-1));
    for dummycount := 0 to MAXO do
    if HexValue and BITSET[dummycount] > 0 then
      (FindComponent( 'cb_output' + inttostr(dummycount))as tcheckbox).Checked := True
    else
      (FindComponent( 'cb_output' + inttostr(dummycount))as tcheckbox).Checked := false;
  end;
  if Receivestring[1] = 'i' then //Input-Meldungen auswerten
  begin
    HexValue := HextoInt(copy(ReceiveString,
       pos(';',ReceiveString)+1,
       length(ReceiveString)-pos(';',ReceiveString)-1));
    for dummycount := 0 to MAXI do
    if HexValue and BITSET[dummycount] > 0 then
      (FindComponent( 'cb_input' + inttostr(dummycount))as tcheckbox).Checked := True
    else
      (FindComponent( 'cb_input' + inttostr(dummycount))as tcheckbox).Checked := false;
  end;
  if Receivestring[1] = 'c' then //Counter-Meldungen auswerten
  begin
    if pos(';',ReceiveString) = 9 then //Counter0 bis Counter9
      (FindComponent( 'ed_counter' + copy(ReceiveString, 8, 1))as tedit).text :=
        copy(ReceiveString, 10,length(ReceiveString)-10);
    if pos(';',ReceiveString) = 10 then //Counter10 bis Counter11
      (FindComponent( 'ed_counter' + copy(ReceiveString, 8, 2))as tedit).text :=
        copy(ReceiveString, 11,length(ReceiveString)-11);
    if pos(';',ReceiveString) = 8 then //alle Counter zusammen
    begin
      for dummycount := 0 to MAXI - 1 do
      begin
        delete(ReceiveString, 1, pos(';',ReceiveString));
        (FindComponent( 'ed_counter' + inttostr(dummycount))as tedit).text :=
          copy(ReceiveString, 1,pos(';',ReceiveString)-1);
      end;
      delete(ReceiveString, 1, pos(';',ReceiveString));
      (FindComponent( 'ed_counter' + inttostr(MAXI))as tedit).text := copy(ReceiveString, 1,length(ReceiveString)-1);
    end;
  end;  
end;



end.
